## mingw-w64-srecord-1.65.0-1.src.tar.zst

=== CMakeLists.txt ===
#
# srecord - Manipulate EPROM load files
# Copyright (C) 2018 - 2022 Scott Finneran
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

cmake_minimum_required(VERSION 3.22)
project(srecord VERSION "1.65.0")
set(CMAKE_BUILD_TYPE Release)

# Headers are all relative to project root
include_directories(./)

# Support for pulling in dependencies required for Windows install
include(InstallRequiredSystemLibraries)

# Support standard install locations
include(GNUInstallDirs)

# FHS compliant paths for Linux installation
if(NOT WIN32 AND CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
#  set(CMAKE_INSTALL_PREFIX "/opt/${PROJECT_NAME}")
  set(CMAKE_INSTALL_PREFIX "/usr")
endif()

# Pull in the rest of the pieces
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/etc")
include(configure)

# Packaging configuration
include(packaging)

# libsrecord
add_subdirectory(srecord)

# Build srecord executables
add_subdirectory(srec_cat)
add_subdirectory(srec_cmp)
add_subdirectory(srec_info)

# Tests & support tools
enable_testing()
add_subdirectory(test)

# Documentation & Man Pages
add_subdirectory(doc)

# Package SRecord
include(CPack)

=== doc/CMakeLists.txt ===
#
# srecord - Manipulate EPROM load files
# Copyright (C) 2022 Scott Finneran
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

set(VERBOSE yep)

# Build Documentation and man pages

# Tools
configure_file(script/groff.sh           script/groff.sh COPYONLY)
configure_file(script/page_select.sh     script/page_select.sh COPYONLY)
configure_file(script/ref-ptx.sh         script/ref_ptx.sh COPYONLY)
configure_file(script/new.sh             script/new.sh COPYONLY)
configure_file(script/build_ref_index.sh script/build_ref_index.sh COPYONLY)
configure_file(script/man-html-index.sh  script/man-html-index.sh COPYONLY)
configure_file(script/ssp.awk            script/ssp.awk COPYONLY)
configure_file(etc/version.so.in         etc/version.so @ONLY)

set(GROFF sh ${CMAKE_CURRENT_BINARY_DIR}/script/groff.sh)
set(PAGE_SELECT sh script/page_select.sh)
set(NEW_CH sh script/new.sh)
set(REF_PTX sh script/ref_ptx.sh)
set(BUILD_REF_INDEX sh script/build_ref_index.sh)
set(MAN_HTML_INDEX sh script/man-html-index.sh)
set(SSP awk -f script/ssp.awk)
set(PS2PDFEXE sh ${PS2PDF})

# Target directories
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/man1)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/man3)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/man5)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/man)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/man/man1)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/man/man3)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/man/man5)

# man pages
file(GLOB_RECURSE MAN_PAGES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "man*/*.[135]")
file(GLOB_RECURSE MAN_COMMON RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "man*/[zo]_*.so")
file(GLOB_RECURSE NEW_CHANGE_NOTES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "etc/new.*.so")

# ...and now an aside on the subtle differences between linux/unix/posix
# and Windows. Under Msys2, ost tools are able to cope with windows path
# format filenames e.g. C:\msys2\bin. groff sadly, doesn't; specifically
# when handling the -I option. So on Windows, let's give groff an assist
# by using the cygpath tool to pass it in unix format.
if(WIN32)
  execute_process(COMMAND ${CYGPATH} -u ${CMAKE_CURRENT_SOURCE_DIR}
    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
    OUTPUT_VARIABLE CMAKE_CURRENT_SOURCE_DIR_UNIX_FORMAT
    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)

  execute_process(COMMAND ${CYGPATH} -u ${CMAKE_CURRENT_BINARY_DIR}
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}"
    OUTPUT_VARIABLE CMAKE_CURRENT_BINARY_DIR_UNIX_FORMAT
    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
else()
  set(CMAKE_CURRENT_SOURCE_DIR_UNIX_FORMAT ${CMAKE_CURRENT_SOURCE_DIR})
  set(CMAKE_CURRENT_BINARY_DIR_UNIX_FORMAT ${CMAKE_CURRENT_BINARY_DIR})
endif()

foreach(m_src ${MAN_PAGES})
  # troff formatted man pages
  set(m_target ${CMAKE_CURRENT_BINARY_DIR}/${m_src})
  add_custom_command(OUTPUT ${m_target}
#    COMMAND soelim -I${CMAKE_CURRENT_SOURCE_DIR}  ${m_src} | sed '/^[.]XX ./d' > ${m_target}
    COMMAND soelim -I${CMAKE_CURRENT_SOURCE_DIR} ${m_src} > ${m_target}
    DEPENDS ${m_src} ${MAN_COMMON}
    COMMENT "Building ${m_target}"
    VERBATIM)
  list(APPEND MAN_PAGE_OUTPUTS ${m_target})

  # HTML formatted man pages for web viewing
  set(m_target ${CMAKE_CURRENT_BINARY_DIR}/html/man/${m_src}.html)
  cmake_path(GET m_src STEM image_stem_name)
  cmake_path(GET m_target PARENT_PATH m_target_path)
  add_custom_command(OUTPUT ${m_target}
    COMMAND ${GROFF} -Thtml -t -man -I${CMAKE_CURRENT_SOURCE_DIR_UNIX_FORMAT} -I${CMAKE_CURRENT_BINARY_DIR_UNIX_FORMAT} -P-I${image_stem_name} ${m_src} > ${m_target}
    DEPENDS ${m_src} ${MAN_COMMON}
    WORKING_DIRECTORY ${m_target_path}
    COMMENT "Building ${m_target} in ${m_target_path}"
    VERBATIM)
  list(APPEND HTML_MAN_PAGE_OUTPUTS ${m_target})
endforeach()

# Generate the index page for the HTML formatted man pages
set(i_target ${CMAKE_CURRENT_BINARY_DIR}/html/man/index.html)
set(HTML_MAN_PAGE_INDEX ${i_target})
add_custom_command(OUTPUT ${HTML_MAN_PAGE_INDEX}
  COMMAND ${MAN_HTML_INDEX} ${MAN_PAGES} > ${i_target}
  DEPENDS ${MAN_PAGES} ${MAN_COMMON}
  COMMENT "Building the HTML man page index"
  VERBATIM)

add_custom_target(man ALL DEPENDS ${MAN_PAGE_OUTPUTS})
if(NOT WIN32)
  # groff which is used to generate HTML formatted man pages relies on underlying
  # tools from the netpmb package which is as yet unsupported under MSYS2.
  # For now, building HTML web pages only run
  add_custom_target(man-html ALL DEPENDS ${HTML_MAN_PAGE_OUTPUTS} ${HTML_MAN_PAGE_INDEX})
endif()

# The website
file(GLOB_RECURSE WEBSITE_IMAGES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
  "html/*.png" "html/*.ico")
foreach(i ${WEBSITE_IMAGES})
  configure_file(${i} ${i} COPYONLY)
endforeach()

file(GLOB_RECURSE WEB_PAGES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "html/*.html")
foreach(w_src ${WEB_PAGES})
  set(w_target ${CMAKE_CURRENT_BINARY_DIR}/${w_src})
  add_custom_command(OUTPUT ${w_target}
    COMMAND ${GROFF} -Tascii -t -P-bcu -man -I${CMAKE_CURRENT_SOURCE_DIR} ${w_src} | ${SSP} > ${w_target}
    DEPENDS ${w_src}
    COMMENT "Building ${w_target}"
    VERBATIM)
  list(APPEND WEB_PAGE_OUTPUTS ${w_target})
endforeach()
add_custom_target(web-site ALL DEPENDS ${WEB_PAGE_OUTPUTS})

# Reference Manual Components
set(REF_INDEX ${CMAKE_CURRENT_BINARY_DIR}/etc/ref-index.so)
add_custom_command(OUTPUT ${REF_INDEX}
  COMMAND ${BUILD_REF_INDEX} ${CMAKE_CURRENT_SOURCE_DIR} ${REF_INDEX} ${MAN_PAGES}
  DEPENDS ${MAN_PAGES} ${CMAKE_CURRENT_SOURCE_DIR}/script/ref-ptx.ignore ${CMAKE_CURRENT_SOURCE_DIR}/script/ref-ptx1.awk ${CMAKE_CURRENT_SOURCE_DIR}/script/ref-ptx2.awk
  COMMENT "Building ${REF_INDEX}"
  VERBATIM
  )

set(REF_PARTS ${CMAKE_CURRENT_BINARY_DIR}/etc/ref-parts.so)
add_custom_command(OUTPUT ${REF_PARTS}
  COMMAND ${REF_PTX} ${MAN_PAGES} > ${REF_PARTS}
  DEPENDS ${MAN_PAGES} ${CMAKE_CURRENT_SOURCE_DIR}/script/ref-ptx.sh
  COMMENT "Building ${REF_PARTS}"
  VERBATIM
  )

set(NEW_CHANGES ${CMAKE_CURRENT_BINARY_DIR}/etc/new.so)
add_custom_command(OUTPUT ${NEW_CHANGES}
  COMMAND ${NEW_CH} -r ${NEW_CHANGE_NOTES} > ${NEW_CHANGES}
  DEPENDS ${NEW_CHANGE_NOTES} ${CMAKE_CURRENT_SOURCE_DIR}/script/ref-ptx.sh
  COMMENT "Building ${NEW_CHANGES}"
  VERBATIM
  )

# Standalone Documents

# Transform man page(s) (ie troff format files) into a PDF
FUNCTION(ADD_DOC TARGET SOURCE DEPS)
  add_custom_command(OUTPUT ${TARGET}
    COMMAND ${GROFF} -Tps -s -I${CMAKE_CURRENT_SOURCE_DIR_UNIX_FORMAT} -I${CMAKE_CURRENT_BINARY_DIR_UNIX_FORMAT} -t -man ${SOURCE} > ${TARGET}.ps.tmp
    COMMAND ${PAGE_SELECT} ${CMAKE_CURRENT_SOURCE_DIR}/etc/page-list.awk ${TARGET}.ps.tmp ${TARGET}.ps
    COMMAND ${PS2PDFEXE} ${TARGET}.ps ${TARGET}
    COMMAND rm ${TARGET}.ps ${TARGET}.ps.tmp
    DEPENDS ${SOURCE} ${DEPS}
    COMMENT "Building ${TARGET}"
    VERBATIM)
  list(APPEND DOC_TARGETS ${TARGET})
  set(DOC_TARGETS ${DOC_TARGETS} PARENT_SCOPE)
ENDFUNCTION()

ADD_DOC(${CMAKE_CURRENT_BINARY_DIR}/BUILDING.pdf ${CMAKE_CURRENT_SOURCE_DIR}/etc/BUILDING.man "")
ADD_DOC(${CMAKE_CURRENT_BINARY_DIR}/README.pdf ${CMAKE_CURRENT_SOURCE_DIR}/etc/README.man "${NEW_CHANGES}")
ADD_DOC(${CMAKE_CURRENT_BINARY_DIR}/change_log.pdf ${CMAKE_CURRENT_SOURCE_DIR}/etc/change_log.man "${NEW_CHANGES}")
ADD_DOC(${CMAKE_CURRENT_BINARY_DIR}/reference-${srecord_VERSION_MAJOR}.${srecord_VERSION_MINOR}.pdf
        ${CMAKE_CURRENT_SOURCE_DIR}/etc/reference.man "${REF_PARTS};${REF_INDEX};${NEW_CHANGES}")
add_custom_target(doco ALL DEPENDS ${DOC_TARGETS})

# Installation
# A copy of the generated PDFs In the docdir for local reference
install(FILES ${DOC_TARGETS}
        DESTINATION ${CMAKE_INSTALL_DOCDIR}/)
# Install a copy of the generated PDFs for the website
install(FILES ${DOC_TARGETS}
        DESTINATION ${CMAKE_INSTALL_DOCDIR}/htdocs)

# Install all the man pages on not-windows
if(NOT WIN32)
  set(sections 1 3 5)
  foreach(i ${sections})
    install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/man${i}/
            DESTINATION ${CMAKE_INSTALL_MANDIR}/man${i}
	    FILES_MATCHING PATTERN "*.${i}")
  endforeach()
endif()

# Install the website
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/
        DESTINATION ${CMAKE_INSTALL_DOCDIR}/htdocs
 	COMPONENT website)

=== srec_cat/CMakeLists.txt ===
#
# srecord - Manipulate EPROM load files
# Copyright (C) 2022 Scott Finneran
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

# Build srecord executable
file(GLOB_RECURSE SREC_CAT_SRC "*.cc")
add_executable(srec_cat ${SREC_CAT_SRC})
target_link_libraries(srec_cat lib_srecord ${LIB_GCRYPT})

INSTALL_SRECORD_EXECUTABLE_TARGET(srec_cat)

=== srec_cmp/CMakeLists.txt ===
#
# srecord - Manipulate EPROM load files
# Copyright (C) 2022 Scott Finneran
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

# Build srecord executable
file(GLOB_RECURSE SREC_CMP_SRC "*.cc")
add_executable(srec_cmp ${SREC_CMP_SRC})
target_link_libraries(srec_cmp lib_srecord ${LIB_GCRYPT})

INSTALL_SRECORD_EXECUTABLE_TARGET(srec_cmp)

=== srec_info/CMakeLists.txt ===
#
# srecord - Manipulate EPROM load files
# Copyright (C) 2022 Scott Finneran
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

# Build srecord executable
file(GLOB_RECURSE SREC_INFO_SRC "*.cc")
add_executable(srec_info ${SREC_INFO_SRC})
target_link_libraries(srec_info lib_srecord ${LIB_GCRYPT})

INSTALL_SRECORD_EXECUTABLE_TARGET(srec_info)

=== srecord/CMakeLists.txt ===
#
# srecord - Manipulate EPROM load files
# Copyright (C) 2018 - 2022 Scott Finneran
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

# lib_srecord - Need to move away from globbing
file(GLOB_RECURSE LIB_SRECORD_SRC "*.cc")
file(GLOB_RECURSE LIB_SRECORD_HDR "*.h")

message(STATUS "gcrypt location ${LIB_GCRYPT}")
add_library(lib_srecord STATIC ${LIB_SRECORD_SRC} ${LIB_SRECORD_HDR} ${LIB_GCRYPT})

# Install the library
install(TARGETS lib_srecord
        DESTINATION ${CMAKE_INSTALL_LIBDIR})

# Install the development headers
# A more modern approach would use a cmake 3.23 FILE SET
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
        FILES_MATCHING PATTERN "*.h")

# Install the Doxygen output for the website
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
        DESTINATION ${CMAKE_INSTALL_DOCDIR}/htdocs/srecord
 	COMPONENT website)

# Generate config.h to suit local environment
configure_file(config.h.in config.h @ONLY)
configure_file(patchlevel.h.in patchlevel.h @ONLY)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# Generate doxygen content
doxygen_add_docs(doxygen
                 ${LIB_SRECORD_HDR}
		 ALL)

=== test/CMakeLists.txt ===
#
# srecord - Manipulate EPROM load files
# Copyright (C) 2018 Scott Finneran
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

# Build test support executables
file(GLOB_RECURSE TEST_ARGLEX_AMBIGUOUS_SRC "arglex_ambiguous/*.cc")
add_executable(test_arglex_ambiguous ${TEST_ARGLEX_AMBIGUOUS_SRC})
target_link_libraries(test_arglex_ambiguous lib_srecord ${LIB_GCRYPT})

file(GLOB_RECURSE TEST_CRC16_SRC "crc16/*.cc")
add_executable(test_crc16 ${TEST_CRC16_SRC})
target_link_libraries(test_crc16 lib_srecord)

file(GLOB_RECURSE TEST_FLETCHER16_SRC "fletcher16/*.cc")
add_executable(test_fletcher16 ${TEST_FLETCHER16_SRC})
target_link_libraries(test_fletcher16 lib_srecord)

file(GLOB_RECURSE TEST_HYPHEN_SRC "hyphen/*.cc")
add_executable(test_hyphen ${TEST_HYPHEN_SRC})
target_link_libraries(test_hyphen lib_srecord)

file(GLOB_RECURSE TEST_URL_DECODE_SRC "url_decode/*.cc")
add_executable(test_url_decode ${TEST_URL_DECODE_SRC})
target_link_libraries(test_url_decode lib_srecord)

configure_file(test_prelude.sh test_prelude COPYONLY)

# Tests
enable_testing()
file(GLOB_RECURSE SRECORD_TESTS "*/*.sh")
foreach(t ${SRECORD_TESTS})
  cmake_path(GET t FILENAME filename)

  # Extract test description from .sh file
  file(STRINGS ${t} test_subject REGEX ^TEST_SUBJECT)
  string(REGEX REPLACE "TEST_SUBJECT\=" "" subject ${test_subject})
  set(test_name "${filename}: ${subject}")

  add_test(NAME ${test_name} COMMAND $ENV{SHELL} ${t})
  set_property(TEST ${test_name} APPEND PROPERTY
      ENVIRONMENT_MODIFICATION
      PATH=path_list_prepend:${CMAKE_BINARY_DIR}
      PATH=path_list_prepend:${CMAKE_BINARY_DIR}/srec_cat
      PATH=path_list_prepend:${CMAKE_BINARY_DIR}/srec_cmp
      PATH=path_list_prepend:${CMAKE_BINARY_DIR}/srec_info
      PATH=path_list_prepend:${CMAKE_BINARY_DIR}/test
      PATH=path_list_prepend:${CMAKE_SOURCE_DIR}/script)
endforeach()

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>

_realname=srecord
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=1.65.0
pkgrel=1
pkgdesc="The SRecord package is a collection of powerful tools for manipulating EPROM load files (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://srecord.sourceforge.io/"
license=('spdx:GPL-3.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-libgcrypt")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-doxygen"
             "${MINGW_PACKAGE_PREFIX}-ghostscript"
             "${MINGW_PACKAGE_PREFIX}-graphviz"
             groff)

source=("https://sourceforge.net/projects/srecord/files/srecord/${pkgver:0:4}/srecord-${pkgver}-Source.tar.gz"
        "0001-undef-msvcrt-config-messy.patch"
        "0003-no-pdf-docs.patch"
        "0004-manpages-mingw.patch"
        "0005-no-install-deps.patch"
        "0006-lib-name.patch")
sha256sums=('81c3d07cf15ce50441f43a82cefd0ac32767c535b5291bcc41bd2311d1337644'
            'f5f606656e77f82f11d6481fcecdcc19fc360086a1269ce34ae6497fce1056e9'
            '2a0c612f31b30707637018be29d92f7dc6f4f0736b89a097c823ff94a06c6dfb'
            '2078be995995f702f7f62e530ce705bdcd2cae8ee94949874fb468b815e3ffa4'
            'aeaa94c4b2fb0991bdbb6613f22f0482b6d45f4f3c05dd21efbdca82625014fa'
            'fadebb4cf14ef800a9cf24e27131b0ec2443f355af6af03de02dcb853599c1ef')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Nbp1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  cd "$srcdir/${_realname}-${pkgver}-Source"

  apply_patch_with_msg \
    0001-undef-msvcrt-config-messy.patch \
    0003-no-pdf-docs.patch \
    0004-manpages-mingw.patch \
    0005-no-install-deps.patch \
    0006-lib-name.patch
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  #CXXFLAGS+=" -Wno-deprecated-declarations -Wno-unknown-pragmas" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=;" \
    "${MINGW_PREFIX}"/bin/cmake.exe -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DCMAKE_STATIC_LIBRARY_PREFIX="" \
      "${_extra_config[@]}" \
      ../${_realname}-${pkgver}-Source

  "${MINGW_PREFIX}"/bin/cmake.exe --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}-Source/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
